#include "StdAfx.h"

#if _MSC_VER >= 1400
#define _CRT_SECURE_NO_DEPRECATE 1
#endif

#include <Windows.h>
#include <tchar.h>
#include "updateutil.h"
#include <strsafe.h>
#pragma warning(disable:4995)

UPDATE CompareVersion(const _VERSION verCurrent, const _VERSION verNew)
{
	if ( verCurrent.dwVer0 < verNew.dwVer0 )
	{
		return update_major;
	}
	else if ( verCurrent.dwVer0 > verNew.dwVer0 )
	{
		return update_error;
	}
	else if ( verCurrent.dwVer1 < verNew.dwVer1 )
	{
		return update_major;
	}
	else if ( verCurrent.dwVer1 > verNew.dwVer1 )
	{
		return update_error;
	}
	else if ( verCurrent.dwVer2 < verNew.dwVer2 )
	{
		return update_major;
	}
	else if ( verCurrent.dwVer2 > verNew.dwVer2 )
	{
		return update_error;
	}
	else if ( verCurrent.dwVer3 < verNew.dwVer3 )
	{
		return update_miner;
	}
	else
	{
		return update_none;
	}
}

UPDATE CompareVersion(LPCTSTR szCurrent, LPCTSTR szNew)
{
	_VERSION versionCurrent, versionNew;
	if ( GetVersionFromString(versionCurrent, szCurrent) == FALSE )
	{
		return update_error;
	}
	if ( GetVersionFromString(versionNew, szNew) == FALSE )
	{
		return update_error;
	}

	return CompareVersion(versionCurrent, versionNew);
}



const TCHAR szToken[] = _T(",.");
const int  MAX_VERSION_SIZE	= 64 ;
BOOL GetVersionFromString(_VERSION& ver, const TCHAR *pszVersion)
{
	if ( pszVersion == NULL )
	{
		return FALSE;
	}
	DWORD dwTemp[4];
	memset(dwTemp, 0x00, sizeof(dwTemp));

	TCHAR *pszTok = NULL;
	TCHAR szVersion[MAX_VERSION_SIZE] ;
	StringCchCopy(szVersion, MAX_VERSION_SIZE, pszVersion) ;
	pszTok = _tcstok(szVersion, szToken) ;
	if (pszTok == NULL)
	{
		return FALSE;
	}

	*dwTemp = DWORD(_ttoi(pszTok)) ;

	for (int nIndex = 1; nIndex < 4; nIndex++)
	{
		pszTok = _tcstok(NULL, szToken) ;
		if (pszTok == NULL)
		{
			return FALSE;
		}

		*(dwTemp + nIndex) = DWORD(_ttoi(pszTok)) ;
	}

	ver.dwVer0 = dwTemp[0];
	ver.dwVer1 = dwTemp[1];
	ver.dwVer2 = dwTemp[2];
	ver.dwVer3 = dwTemp[3];

	return TRUE;
}


const TCHAR VERSION_FORMAT[] = _T("%d,%d,%d,%d");
void MakeVersionString(LPTSTR szBuf, const int cch, _VERSION ver)
{
	StringCchPrintf(szBuf, cch, VERSION_FORMAT, ver.dwVer0, ver.dwVer1, ver.dwVer2, ver.dwVer3);
}

